(:server version
  saved in the webapps/bza folder.
  uses "request-parameter" because of an older Exist version
  .xql filename:)
(:--prolog--:)
declare namespace tei = "http://www.tei-c.org/ns/1.0";
declare namespace request = "http://exist-db.org/xquery/request";
declare namespace util = "http://exist-db.org/xquery/util";
declare option exist:serialize "indent=yes media-type=text/html method=xhtml doctype-public=-//W3C//DTD&#160;XHTML&#160;1.1//EN doctype-system=http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd";
(:--body--:)
<html style="background-color:#F0F8FF;font-family:'Arial Unicode MS', sans-serif; margin-left: 5%; margin-top:10%;">
<head>
<title>BZA project search page</title>
</head>
<body>
<h1>Search the <a href="http://buddhistinformatics.ddbc.edu.tw/BZA/bzaComCatWeb.html" title="cluster index">364 text clusters</a> of the <a href="http://buddhistinformatics.ddbc.edu.tw/BZA/" title="home page">BZA project</a>.</h1>
<form>
Search term: <input name="query" type="text" size="20"/><br/>
<input type="submit"/>
</form>
{  (:this is for an older version of eXist in newer versions it is get-parameter:)
let $q := request:request-parameter("query", ""),$timeA := util:system-time(),
$hit := util:eval(concat('collection("/db/bza")/tei:TEI/tei:text/tei:body/tei:div//tei:*/text()[contains(., "',$q, '")]')),$timeB:=util:system-time()
   (:previous used the exist function near (), but that caught only words (from the index)!
     contains() also catches pali and sanskrit words in compounds (e.g. tadrū and tadrūpa�? :)
return
if ($q = "") then
 ()
else
 <div>
 <h2>Search result for {$q} (appears {count($hit)} times)</h2>
  <h4> {seconds-from-duration($timeB - $timeA)} Seconds to process this query</h4>
 <table>
 {
 for $res in $hit/parent::tei:*/parent::tei:*

   (:these construct the 10 character string before and after the query term for the kwic :)
 let $kwic1 := substring(codepoints-to-string(reverse(string-to-codepoints(substring-before($res, $q)))), 1,15)
 let $kwic2 := substring(substring-after($res, $q),1,15)

 let $filename := util:document-name($res)
 let $short := doc("/db/bza/comCatBza.xml")/tei:TEI/tei:text/tei:body/tei:list/tei:item/tei:list/tei:item/tei:ref[@target=$filename]/tei:seg[@type = 'short']

 for $cluster in doc("/db/bza/comCatBza.xml")/tei:TEI/tei:text/tei:body/tei:list/tei:item/tei:list/tei:item/tei:ref[@target=$filename]/ancestor::tei:list[1]/data(@xml:id)

 where not($filename ='comCatBza.xml')
 order by $cluster
 (:Next need to pass two parameter to the clusterSearch.xql because the same file might be in two different clusters:)
 return
 <tr>
      <td style="width:15%; padding:3; font-size:smaller;"><a href="http://buddhistinformatics.ddbc.edu.tw/BZA/clusterSearch.xql?base={$filename},{$cluster}">
      go to file</a> in cluster {$cluster}
      :</td>
      <td style="text-align:right;"> {codepoints-to-string(reverse(string-to-codepoints($kwic1)))} </td>
      <td style="padding-right: 0; margin-right: 0; frame-right:0; background: yellow;">{$q}</td>
      <td style="padding-left: 0; margin-left: 0; text-align:left;">{$kwic2} </td>
      <td>(filename: {$filename})</td>
 </tr>
 }
 </table>
   <h4> Take { seconds-from-duration(util:system-time() - $timeB) } Seconds to show results</h4>
 </div>
}

</body>
</html>
